<template>
  <div align="center">
    <h1 v-if="!pokemonObjetivo">Espere por favor...</h1>
    <div v-else>
      <h1>Quien es este pokemon</h1>
      <h3>Cantidad jugada : {{ contador }}</h3>
      <h4>Acertadas: {{ correctas }}</h4>
      <PokemonPicture
        :idPokemon="pokemonObjetivo.id"
        :mostrarPokemon="mostrarPokemon"
      />
      <PokemonOption
        :pokemons="arregloPokemon"
        @seleccionarPokemon="checkAnswer"
      />
      
      <template v-if="mostrarRespuesta">
        <h2 style="text-align: center">{{ mensaje }}</h2>
        <div v-if="contador < 4">
          <v-row align="center" justify="space-around">
            <v-btn class="nuevo-juego" color="success" @click="nuevoJuego">
              <v-icon left> mdi-cached </v-icon>
              Nuevo Juego
            </v-btn>
          </v-row>
        </div>

        <div v-else>
          <h3>JUEGO TERMINADO</h3>
        </div>
      </template>
    </div>
  </div>
</template>

<script>
import PokemonOption from "../components/PokemonOption.vue";
import PokemonPicture from "../components/PokemonPicture.vue";

import getPokemonOptions from "@/helpers/getPokemonOptions";

export default {
  components: {
    PokemonOption,
    PokemonPicture,
  },

  data() {
    return {
      arregloPokemon: [],
      pokemonObjetivo: null,
      mostrarPokemon: false,
      mostrarRespuesta: false,
      mensaje: "",
      contador: 0,
      correctas: 0,
    };
  },
  methods: {
    async mixPokemonArray() {
      this.arregloPokemon = await getPokemonOptions();
      const numeroRandom = Math.floor(Math.random() * 4);
      this.pokemonObjetivo = this.arregloPokemon[numeroRandom];
    },
    checkAnswer(selectedId) {
      this.mostrarRespuesta = true;
      if (selectedId == this.pokemonObjetivo.id) {
        this.mostrarPokemon = true;
        this.mensaje = `Correcto ${this.pokemonObjetivo.name}`;
        this.correctas = this.correctas + 1;
      } else {
        this.mensaje = `Incorrecto el pokemon correcto es: ${this.pokemonObjetivo.name}`;
        this.selectedId = this.pokemonObjetivo.id;
      }
    },

    nuevoJuego() {
      this.contador = this.contador + 1;
      this.mostrarPokemon = false;
      this.mostrarRespuesta = false;
      this.arregloPokemon = [];
      this.pokemonObjetivo = null;
      this.mixPokemonArray();
      console.log(this.contador);
    },
  },
  mounted() {
    this.mixPokemonArray();
  },
};
</script>

<style scoped>
.nuevo-juego {
  margin-top: 20px;
}
</style>

